<?

class PDF extends FPDF
{

function Justify($text,$w,$h)
{
$tab_paragraphe = explode("\n", $text);
$nb_paragraphe = count($tab_paragraphe);
$j=0;
while ($j<$nb_paragraphe) {
$paragraphe = $tab_paragraphe[$j];
$tab_mot = explode(' ', $paragraphe);
$nb_mot = count($tab_mot);
// *** Handle strings longer than paragraph width
$k=0;
$l=0;
while ($k<$nb_mot) {
$len_mot = strlen ($tab_mot[$k]);
if ($len_mot< ($w-5) )
{
$tab_mot2[$l] = $tab_mot[$k];
$l++;
}
else {
$m=0;
$chaine_lettre='';
while ($m<$len_mot)
{
$lettre = substr($tab_mot[$k], $m, 1);
$len_chaine_lettre = $this->GetStringWidth($chaine_lettre.$lettre);
if ($len_chaine_lettre>($w-7)) {
$tab_mot2[$l] = $chaine_lettre . '-';
$chaine_lettre = $lettre;
$l++;
}
else {
$chaine_lettre .= $lettre;
}
$m++;
}
if ($chaine_lettre) {
$tab_mot2[$l] = $chaine_lettre;
$l++;
}
}
$k++;
}
// *** Justified lines
$nb_mot = count($tab_mot2);
$i=0;
$ligne = '';

while ($i<$nb_mot) {
$mot = $tab_mot2[$i];
$len_ligne = $this->GetStringWidth($ligne . ' ' . $mot);
if ($len_ligne>($w-5)) {
$len_ligne = $this->GetStringWidth($ligne);
$nb_carac = strlen ($ligne);
$ecart = (($w-2) - $len_ligne) / $nb_carac;
$this->_out(sprintf('BT %.3f Tc ET',$ecart*$this->k));
$this->MultiCell($w,$h,$ligne);
$ligne = $mot;
}
else {
if ($ligne) {
$ligne .= ' ' . $mot;
}
else {
$ligne = $mot;
}
}
$i++;
}
// *** Last line
$this->_out('BT 0 Tc ET');
$this->MultiCell($w,$h,$ligne);
$tab_mot = '';
$tab_mot2 = '';
$j++;
}
}

## fine justify


//Load data
function LoadRiData($file)
{
//Read file lines
$lines=file($file);
$data=array();
foreach($lines as $line)
$data[]=explode(';',chop($line));
return $data;
}


//Colored table
function FancyTable($header,$data)
{
//Colors, line width and bold font
$this->SetFillColor(255,255,0);
$this->SetTextColor(255,0,0);
$this->SetDrawColor(128,0,0);
$this->SetLineWidth(.3);
$this->SetFont('','B');
//Header
$w=array(35,120,35);
$this->Cell(190,10,'AZIONI PROMOZIONALI',1,0,'C',1);
$this->Ln();
$this->SetFillColor(255,0,0);
$this->SetTextColor(255);
for($i=0;$i<count($header);$i++)
$this->Cell($w[$i],10,$header[$i],1,0,'C',1);
$this->Ln();
//Color and font restoration
$this->SetFillColor(224,235,255);
$this->SetTextColor(0);
$this->SetFont('');
//Data
$fill=0;
foreach($data as $row)
{
$this->Cell($w[0],10,$row[0],'LR',0,'L',$fill);
$this->Cell($w[1],10,$row[1],'LR',0,'L',$fill);
$this->Cell($w[2],10,$row[2],'LR',0,'R',$fill);
#$this->Cell($w[2],6,number_format($row[2]),'LR',0,'R',$fill);
#$this->Cell($w[3],6,number_format($row[3]),'LR',0,'R',$fill);
$this->Ln();
$fill=!$fill;
}
$this->Cell(array_sum($w),0,'','T');
}

#fine colors

}

?>
